using System.Runtime.Serialization;

namespace CoreLibrary.Exceptions
{
    /// <summary>
    /// Exception levée lorsqu'un code avec une taille invalide est ajouté à la grille.
    /// </summary>
    [Serializable]
    public class CodeInvalideException : Exception
    {
        /// <summary>
        /// Initialise une nouvelle instance de la classe <see cref="CodeInvalideException"/>.
        /// </summary>
        /// <param name="tailleCodeAjoute">La taille du code que vous essayez d'ajouter.</param>
        /// <param name="tailleCodePlateau">La taille du code que le plateau attend.</param>
        private const string messageDefaut = "Le code que vous essayez d'ajouter est invalide.";

        public CodeInvalideException() : base(messageDefaut)
        { }

        public CodeInvalideException(int tailleCodeAjoute, int tailleCodePlateau) :
            base($"Le code que vous essayez d'ajouter est un code de taille {tailleCodeAjoute}, or le plateau attend un code de {tailleCodePlateau}.")
        { }

        public CodeInvalideException(string message) : base(message)
        { }

        public CodeInvalideException(string message, Exception exception) : base(message, exception)
        { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        protected CodeInvalideException(SerializationInfo info, StreamingContext contexte) : base(info, contexte) { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        public override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            base.GetObjectData(info, context);
        }
    }
}
